﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net;

namespace SimpleFileDownloader
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Form1.CheckForIllegalCrossThreadCalls = false;
        }

        private void btnStart_Click(object sender, EventArgs e)
        {
            int lc = tbLinks.Lines.Count();
            DownloadProgress.Maximum = lc;
            if (tbLinks.Text == "")
            {
                MessageBox.Show("Error, no links specified!");
                return;
            }
            if (tbFolderLocation.Text == "")
            {
                MessageBox.Show("Error, no folder specified!");
                return;
            }
            if(!tbFolderLocation.Text.EndsWith("\\"))
            {
                tbFolderLocation.Text += "\\";
            }
            bgw.RunWorkerAsync();
        }

        private void btnStop_Click(object sender, EventArgs e)
        {
            if (bgw.IsBusy)
            {
                bgw.CancelAsync();
            }
        }

        private void btnSelectFolder_Click(object sender, EventArgs e)
        {
            fbd.ShowDialog();
            tbFolderLocation.Text = fbd.SelectedPath + "\\";
        }

        private void bgw_DoWork(object sender, DoWorkEventArgs e)
        {
            try
            {

                string outputfolder = tbFolderLocation.Text;
                WebClient webClient = new WebClient();
                int count = 0;

                foreach (string line in tbLinks.Lines)
                {
                    Uri uri = new Uri(line);
                    string filename = System.IO.Path.GetFileName(uri.LocalPath);
                    webClient.DownloadFile(line, outputfolder + filename);
                    count++;
                    bgw.ReportProgress(count);

                }
                tbStatus.Text += "Downloads complete!";
            }
            catch (System.Net.WebException ex)
            {
                
                if (ex.Status == WebExceptionStatus.ProtocolError)
                {
                    tbStatus.Text += "The link " + ex.Response.ResponseUri.ToString() + " is dead!";
                    MessageBox.Show("One of the links is dead, please remove " + ex.Response.ResponseUri.ToString() + " from the list to continue!");
                }
                else
                {
                    MessageBox.Show("Either one of the links is busted, or you didn't format the text properly, try again!");
                }//
                
                DownloadProgress.Value = 0;
            }
           
        }

        private void bgw_ProgressChanged(object sender, ProgressChangedEventArgs e)
        {
            DownloadProgress.Value = e.ProgressPercentage;
        }
    }
}
